# Serialized Form

## Package org.bouncycastle.asn1

### Class org.bouncycastle.asn1.ASN1ParsingException extends java.lang.IllegalStateException implements Serializable

### Serialized Fields

#### cause

    java.lang.Throwable cause

## Package org.bouncycastle.crypto

### Class org.bouncycastle.crypto.CryptoException extends java.lang.Exception implements Serializable

### Class org.bouncycastle.crypto.DataLengthException extends RuntimeCryptoException implements Serializable

### Class org.bouncycastle.crypto.InvalidCipherTextException extends CryptoException implements Serializable

### Class org.bouncycastle.crypto.MaxBytesExceededException extends RuntimeCryptoException implements Serializable

### Class org.bouncycastle.crypto.RuntimeCryptoException extends java.lang.RuntimeException implements Serializable

## Package org.bouncycastle.crypto.tls

### Class org.bouncycastle.crypto.tls.TlsRuntimeException extends java.lang.RuntimeException implements Serializable

### Serialized Fields

#### e

    java.lang.Throwable e

## Package org.bouncycastle.jce

### Class org.bouncycastle.jce.ProviderConfigurationPermission extends java.security.BasicPermission implements Serializable

### Serialized Fields

#### actions

    java.lang.String actions

#### permissionMask

    int permissionMask

## Package org.bouncycastle.jce.exception

### Class org.bouncycastle.jce.exception.ExtCertificateEncodingException extends java.security.cert.CertificateEncodingException implements Serializable

### Serialized Fields

#### cause

    java.lang.Throwable cause

### Class org.bouncycastle.jce.exception.ExtCertPathBuilderException extends java.security.cert.CertPathBuilderException implements Serializable

### Serialized Fields

#### cause

    java.lang.Throwable cause

### Class org.bouncycastle.jce.exception.ExtCertPathValidatorException extends java.security.cert.CertPathValidatorException implements Serializable

### Serialized Fields

#### cause

    java.lang.Throwable cause

### Class org.bouncycastle.jce.exception.ExtIOException extends java.io.IOException implements Serializable

### Serialized Fields

#### cause

    java.lang.Throwable cause

## Package org.bouncycastle.jce.interfaces

## Package org.bouncycastle.jce.provider

### Class org.bouncycastle.jce.provider.AnnotatedException extends java.lang.Exception implements Serializable

### Serialized Fields

#### _underlyingException

    java.lang.Throwable _underlyingException

### Class org.bouncycastle.jce.provider.BouncyCastleProvider extends java.security.Provider implements Serializable

### Class org.bouncycastle.jce.provider.JCEDHPrivateKey extends java.lang.Object implements Serializable

serialVersionUID:
  311058815616901812L

### Serialization Methods

#### readObject

    private void readObject(java.io.ObjectInputStream in)
                     throws java.io.IOException,
                            java.lang.ClassNotFoundException

Throws:
  `java.io.IOException`
  `java.lang.ClassNotFoundException`

#### writeObject

    private void writeObject(java.io.ObjectOutputStream out)
                      throws java.io.IOException

Throws:
  `java.io.IOException`

### Serialized Fields

#### x

    java.math.BigInteger x

#### dhSpec

    javax.crypto.spec.DHParameterSpec dhSpec

#### attrCarrier

    PKCS12BagAttributeCarrier attrCarrier

### Class org.bouncycastle.jce.provider.JCEDHPublicKey extends java.lang.Object implements Serializable

serialVersionUID:
  -216691575254424324L

### Serialization Methods

#### readObject

    private void readObject(java.io.ObjectInputStream in)
                     throws java.io.IOException,
                            java.lang.ClassNotFoundException

Throws:
  `java.io.IOException`
  `java.lang.ClassNotFoundException`

#### writeObject

    private void writeObject(java.io.ObjectOutputStream out)
                      throws java.io.IOException

Throws:
  `java.io.IOException`

### Serialized Fields

#### y

    java.math.BigInteger y

#### dhSpec

    javax.crypto.spec.DHParameterSpec dhSpec

### Class org.bouncycastle.jce.provider.JCEECPrivateKey extends java.lang.Object implements Serializable

### Serialization Methods

#### readObject

    private void readObject(java.io.ObjectInputStream in)
                     throws java.io.IOException,
                            java.lang.ClassNotFoundException

Throws:
  `java.io.IOException`
  `java.lang.ClassNotFoundException`

#### writeObject

    private void writeObject(java.io.ObjectOutputStream out)
                      throws java.io.IOException

Throws:
  `java.io.IOException`

### Serialized Fields

#### algorithm

    java.lang.String algorithm

#### d

    java.math.BigInteger d

#### ecSpec

    java.security.spec.ECParameterSpec ecSpec

#### withCompression

    boolean withCompression

#### publicKey

    DERBitString publicKey

#### attrCarrier

    org.bouncycastle.jce.provider.PKCS12BagAttributeCarrierImpl attrCarrier

### Class org.bouncycastle.jce.provider.JCEECPublicKey extends java.lang.Object implements Serializable

### Serialization Methods

#### readObject

    private void readObject(java.io.ObjectInputStream in)
                     throws java.io.IOException,
                            java.lang.ClassNotFoundException

Throws:
  `java.io.IOException`
  `java.lang.ClassNotFoundException`

#### writeObject

    private void writeObject(java.io.ObjectOutputStream out)
                      throws java.io.IOException

Throws:
  `java.io.IOException`

### Serialized Fields

#### algorithm

    java.lang.String algorithm

#### q

    org.bouncycastle.math.ec.ECPoint q

#### ecSpec

    java.security.spec.ECParameterSpec ecSpec

#### withCompression

    boolean withCompression

#### gostParams

    GOST3410PublicKeyAlgParameters gostParams

### Class org.bouncycastle.jce.provider.JCEElGamalPrivateKey extends java.lang.Object implements Serializable

serialVersionUID:
  4819350091141529678L

### Serialization Methods

#### readObject

    private void readObject(java.io.ObjectInputStream in)
                     throws java.io.IOException,
                            java.lang.ClassNotFoundException

Throws:
  `java.io.IOException`
  `java.lang.ClassNotFoundException`

#### writeObject

    private void writeObject(java.io.ObjectOutputStream out)
                      throws java.io.IOException

Throws:
  `java.io.IOException`

### Serialized Fields

#### x

    java.math.BigInteger x

#### elSpec

    ElGamalParameterSpec elSpec

#### attrCarrier

    org.bouncycastle.jce.provider.PKCS12BagAttributeCarrierImpl attrCarrier

### Class org.bouncycastle.jce.provider.JCEElGamalPublicKey extends java.lang.Object implements Serializable

serialVersionUID:
  8712728417091216948L

### Serialization Methods

#### readObject

    private void readObject(java.io.ObjectInputStream in)
                     throws java.io.IOException,
                            java.lang.ClassNotFoundException

Throws:
  `java.io.IOException`
  `java.lang.ClassNotFoundException`

#### writeObject

    private void writeObject(java.io.ObjectOutputStream out)
                      throws java.io.IOException

Throws:
  `java.io.IOException`

### Serialized Fields

#### y

    java.math.BigInteger y

#### elSpec

    ElGamalParameterSpec elSpec

### Class org.bouncycastle.jce.provider.JCEPBEKey extends java.lang.Object implements Serializable

### Serialized Fields

#### algorithm

    java.lang.String algorithm

#### oid

    DERObjectIdentifier oid

#### type

    int type

#### digest

    int digest

#### keySize

    int keySize

#### ivSize

    int ivSize

#### param

    CipherParameters param

#### pbeKeySpec

    javax.crypto.spec.PBEKeySpec pbeKeySpec

#### tryWrong

    boolean tryWrong

### Class org.bouncycastle.jce.provider.JCERSAPrivateCrtKey extends JCERSAPrivateKey implements Serializable

serialVersionUID:
  7834723820638524718L

### Serialized Fields

#### publicExponent

    java.math.BigInteger publicExponent

#### primeP

    java.math.BigInteger primeP

#### primeQ

    java.math.BigInteger primeQ

#### primeExponentP

    java.math.BigInteger primeExponentP

#### primeExponentQ

    java.math.BigInteger primeExponentQ

#### crtCoefficient

    java.math.BigInteger crtCoefficient

### Class org.bouncycastle.jce.provider.JCERSAPrivateKey extends java.lang.Object implements Serializable

serialVersionUID:
  5110188922551353628L

### Serialization Methods

#### readObject

    private void readObject(java.io.ObjectInputStream in)
                     throws java.io.IOException,
                            java.lang.ClassNotFoundException

Throws:
  `java.io.IOException`
  `java.lang.ClassNotFoundException`

#### writeObject

    private void writeObject(java.io.ObjectOutputStream out)
                      throws java.io.IOException

Throws:
  `java.io.IOException`

### Serialized Fields

#### modulus

    java.math.BigInteger modulus

#### privateExponent

    java.math.BigInteger privateExponent

#### attrCarrier

    org.bouncycastle.jce.provider.PKCS12BagAttributeCarrierImpl attrCarrier

### Class org.bouncycastle.jce.provider.JCERSAPublicKey extends java.lang.Object implements Serializable

serialVersionUID:
  2675817738516720772L

### Serialized Fields

#### modulus

    java.math.BigInteger modulus

#### publicExponent

    java.math.BigInteger publicExponent

### Class org.bouncycastle.jce.provider.JDKDSAPrivateKey extends java.lang.Object implements Serializable

serialVersionUID:
  -4677259546958385734L

### Serialization Methods

#### readObject

    private void readObject(java.io.ObjectInputStream in)
                     throws java.io.IOException,
                            java.lang.ClassNotFoundException

Throws:
  `java.io.IOException`
  `java.lang.ClassNotFoundException`

#### writeObject

    private void writeObject(java.io.ObjectOutputStream out)
                      throws java.io.IOException

Throws:
  `java.io.IOException`

### Serialized Fields

#### x

    java.math.BigInteger x

#### dsaSpec

    java.security.interfaces.DSAParams dsaSpec

#### attrCarrier

    org.bouncycastle.jce.provider.PKCS12BagAttributeCarrierImpl attrCarrier

### Class org.bouncycastle.jce.provider.JDKDSAPublicKey extends java.lang.Object implements Serializable

serialVersionUID:
  1752452449903495175L

### Serialization Methods

#### readObject

    private void readObject(java.io.ObjectInputStream in)
                     throws java.io.IOException,
                            java.lang.ClassNotFoundException

Throws:
  `java.io.IOException`
  `java.lang.ClassNotFoundException`

#### writeObject

    private void writeObject(java.io.ObjectOutputStream out)
                      throws java.io.IOException

Throws:
  `java.io.IOException`

### Serialized Fields

#### y

    java.math.BigInteger y

#### dsaSpec

    java.security.interfaces.DSAParams dsaSpec

### Class org.bouncycastle.jce.provider.JDKGOST3410PrivateKey extends java.lang.Object implements Serializable

### Serialized Fields

#### x

    java.math.BigInteger x

#### gost3410Spec

    GOST3410Params gost3410Spec

#### attrCarrier

    PKCS12BagAttributeCarrier attrCarrier

### Class org.bouncycastle.jce.provider.JDKGOST3410PublicKey extends java.lang.Object implements Serializable

### Serialized Fields

#### y

    java.math.BigInteger y

#### gost3410Spec

    GOST3410Params gost3410Spec

### Class org.bouncycastle.jce.provider.PKIXCertPath extends java.security.cert.CertPath implements Serializable

### Serialized Fields

#### certificates

    java.util.List<E> certificates

### Class org.bouncycastle.jce.provider.PKIXNameConstraintValidatorException extends java.lang.Exception implements Serializable

### Class org.bouncycastle.jce.provider.X509CertificateObject extends java.security.cert.X509Certificate implements Serializable

### Serialized Fields

#### c

    X509CertificateStructure c

#### basicConstraints

    BasicConstraints basicConstraints

#### keyUsage

    boolean[] keyUsage

#### hashValueSet

    boolean hashValueSet

#### hashValue

    int hashValue

#### attrCarrier

    PKCS12BagAttributeCarrier attrCarrier

## Package org.bouncycastle.jce.provider.asymmetric

### Class org.bouncycastle.jce.provider.asymmetric.ECMappings extends java.util.HashMap implements Serializable

## Package org.bouncycastle.jce.provider.symmetric

### Class org.bouncycastle.jce.provider.symmetric.AESMappings extends java.util.HashMap implements Serializable

### Class org.bouncycastle.jce.provider.symmetric.CamelliaMappings extends java.util.HashMap implements Serializable

### Class org.bouncycastle.jce.provider.symmetric.CAST5Mappings extends java.util.HashMap implements Serializable

### Class org.bouncycastle.jce.provider.symmetric.Grain128Mappings extends java.util.HashMap implements Serializable

### Class org.bouncycastle.jce.provider.symmetric.Grainv1Mappings extends java.util.HashMap implements Serializable

### Class org.bouncycastle.jce.provider.symmetric.IDEAMappings extends java.util.HashMap implements Serializable

### Class org.bouncycastle.jce.provider.symmetric.NoekeonMappings extends java.util.HashMap implements Serializable

### Class org.bouncycastle.jce.provider.symmetric.SEEDMappings extends java.util.HashMap implements Serializable

## Package org.bouncycastle.jce.spec

### Class org.bouncycastle.jce.spec.IEKeySpec extends java.lang.Object implements Serializable

### Serialized Fields

#### pubKey

    java.security.PublicKey pubKey

#### privKey

    java.security.PrivateKey privKey

### Class org.bouncycastle.jce.spec.MQVPrivateKeySpec extends java.lang.Object implements Serializable

### Serialized Fields

#### staticPrivateKey

    java.security.PrivateKey staticPrivateKey

#### ephemeralPrivateKey

    java.security.PrivateKey ephemeralPrivateKey

#### ephemeralPublicKey

    java.security.PublicKey ephemeralPublicKey

### Class org.bouncycastle.jce.spec.MQVPublicKeySpec extends java.lang.Object implements Serializable

### Serialized Fields

#### staticKey

    java.security.PublicKey staticKey

#### ephemeralKey

    java.security.PublicKey ephemeralKey

## Package org.bouncycastle.ocsp

### Class org.bouncycastle.ocsp.OCSPException extends java.lang.Exception implements Serializable

### Serialized Fields

#### e

    java.lang.Exception e

## Package org.bouncycastle.openssl

### Class org.bouncycastle.openssl.EncryptionException extends java.io.IOException implements Serializable

### Serialized Fields

#### cause

    java.lang.Throwable cause

### Class org.bouncycastle.openssl.PasswordException extends java.io.IOException implements Serializable

### Class org.bouncycastle.openssl.PEMException extends java.io.IOException implements Serializable

### Serialized Fields

#### underlying

    java.lang.Exception underlying

## Package org.bouncycastle.util

### Class org.bouncycastle.util.StoreException extends java.lang.RuntimeException implements Serializable

### Serialized Fields

#### _e

    java.lang.Throwable _e

### Class org.bouncycastle.util.StreamParsingException extends java.lang.Exception implements Serializable

### Serialized Fields

#### _e

    java.lang.Throwable _e

## Package org.bouncycastle.util.io

### Class org.bouncycastle.util.io.StreamOverflowException extends java.io.IOException implements Serializable

## Package org.bouncycastle.util.test

### Class org.bouncycastle.util.test.FixedSecureRandom extends java.security.SecureRandom implements Serializable

### Serialized Fields

#### _data

    byte[] _data

#### _index

    int _index

#### _intPad

    int _intPad

### Class org.bouncycastle.util.test.TestFailedException extends java.lang.RuntimeException implements Serializable

### Serialized Fields

#### _result

    TestResult _result

## Package org.bouncycastle.x509

### Class org.bouncycastle.x509.CertPathReviewerException extends org.bouncycastle.i18n.LocalizedException implements Serializable

### Serialized Fields

#### index

    int index

#### certPath

    java.security.cert.CertPath certPath

### Class org.bouncycastle.x509.NoSuchParserException extends java.lang.Exception implements Serializable

### Class org.bouncycastle.x509.NoSuchStoreException extends java.lang.Exception implements Serializable

## Package org.bouncycastle.x509.util

### Class org.bouncycastle.x509.util.StreamParsingException extends java.lang.Exception implements Serializable

### Serialized Fields

#### _e

    java.lang.Throwable _e